'****************************************************************
'* File	: L0101.BAS                              
'* Description 	: ADCIN command operation          
'* Compiler : PICBASIC PRO demo/V2.44 or higher
'* Author :	Natthaphol Wongsuntornchai
'* Copyright 2004 Innovative Experiment Co.,Ltd.    
'****************************************************************
@   DEVICE  PIC16F877,HS_OSC,LVP_OFF,BOD_OFF,WDT_OFF
        
DEFINE  OSC         20      		' High speed mode 
DEFINE   NO_CLRWDT   1      		' Use for optimize code <turn-off wdt. only>
DEFINE  LCD_BITS    4       		' 4 bit mode
DEFINE  LCD_LINES   2       		' LCD line
DEFINE  LCD_DREG    PORTD   	' Use port D as data bus
DEFINE  LCD_DBIT    4       		' Data start bit 4 (RD4)
DEFINE  LCD_RSREG   PORTC   	' RC0 = RS pin
DEFINE  LCD_RSBIT   0
DEFINE  LCD_EREG    PORTC   	' RC5 = Enable pin
DEFINE  LCD_EBIT    5
           
DEFINE  ADC_BITS     10     		' Specified 10 bits result
DEFINE  ADC_CLOCK    3      		' Clock from FRC
DEFINE  ADC_SAMPLEUS 500    	' Sample times

RESULT  VAR WORD
PAUSE   1000		' Delay 1 second for LCD start-up
LCDOUT  $FE,1       		' Clear display         
ADCON1  = %00000000    	' RA and RE as analog port, Vref = VDD       
TRISA   = %11111111   	' All port A are input
TRISE	= %00000111	    	' RE2:RE0 are input 	
ADCON1.7 = 1		' Result in right justify formatted	        
' ADCON1.7 = 0  	    	' Result in left  justify formatted        	

L1:  ADCIN   0,RESULT            			' Read channel 0
     LCDOUT  $FE,$80,"ADC RESULT=" ' Send text on line 1/0
     LCDOUT  $FE,$C0,bin16 RESULT 	' Show 16 bits result in binary formatted            
     GOTO    L1                   				' Do again 
