'****************************************************************
'*   File	: L0201.BAS                                      
'*  Description 	: ADCIN command operation with PIC12F675                        *
'*Author :	Natthaphol Wongsuntornchai
'* Copyright 2004 Innovative Experiment Co.,Ltd.     
'****************************************************************
@ DEVICE PIC12F675,INTRC_OSC,MCLR_OFF,PWRT_OFF,BOD_OFF,WDT_OFF

' ADC PARAMETERS	
DEFINE	OSCCAL_1K    1	' Oscillator calibration for 1K device
DEFINE 	ADC_BITS     10  	' Specified 10 bits result
DEFINE  	ADC_CLOCK    3    	' Clock from FRC
DEFINE  	ADC_SAMPLEUS 100  	' Sample times

' DEBUG PARAMETERS <FOR AX-12>
DEFINE	DEBUG_REG	GPIO
DEFINE	DEBUG_BIT	1	' Use GP1 as TX pin
DEFINE	DEBUG_MODE	0	' Non-invert mode <use MAX232>
DEFINE	DEBUG_BAUD	4800	' Baudrate 4800 bps
CR	CON	13			' Carriage Return
LF	CON	10			' Line feed	
		
' If need 10 bits result this variable should be set as word size only
RESULT VAR	WORD 	 	' For 10 bits result	
		
' DEFINE ADC CHANNELS
CH0	CON 	0		' GP0 <pin 7>
CH1	CON	1		' GP1 <pin 6>
CH2	CON  	2		' GP2 <pin 5>
CH3	CON	3		' GP4 <pin 3>

' INITIAL REGISTER THAT ASSOCIATED WITH ADC MODULE		
TRISIO  =  %11111111	' Set GP4,GP2:GP0 as input  port
ANSEL	=  %00001111    	' Set GP4,GP2:GP0 as analog port 	
ADCON0.6 = 0		' Vref = VDD			
ADCON0.7 = 1         		' Right justified	
'++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
LOOP1 :	
	ADCIN  	CH0,RESULT
	DEBUG	"RESULT:=",BIN10 RESULT,":",#RESULT ,CR,LF ' Show text on PC	
	PAUSE	300		' Delay 300 ms
	GOTO	LOOP1
