'****************************************************************
'* File	: L0301.BAS                             						
'* Description 	: ASM....ENDASM command operation	
'****************************************************************
@  DEVICE  PIC16F877,HS_OSC,LVP_OFF,BOD_OFF,WDT_OFF,PWRT_OFF
DEFINE	OSC	20		' Use crystal 20 MHz.
I		VAR	BYTE		' Variable = byte size		
DELAY   		CON	500		' Constant for delay (500 ms)
LED1		VAR	PORTB.3	' LED1 = RB3
LED2		VAR	PORTB.4	' LED2 = RB4
LED3 		VAR  	PORTB.5 	' LED3 = RB5

FOR I = 1 TO 6			' Toggle LED1 for 6 times 
	TOGGLE  LED3            ' <high 3,low 3>
	PAUSE   DELAY	  	' Delay time
NEXT	I
                            
@ CALL BLINK     			; Call assembly subroutine name BLINK     
	HIGH    LED1           		' Turn-on LED1
     END                     ' End of job
        
' ASSEMBLY SUBROUTINES  
ASM                     					; Assembly start here 
dv1	equ	70h             			; Defined address of RAM(Common RAM)
dv2	equ	71h
dv3	equ	72h
cnt8	equ     73h
BLINK	                          
	clrf	portb			; Clear latch of portb 
	bsf	status,rp0		; Access bank1	
	movlw	11000111b		; Make RB5:RB3 as output port	
	movwf	trisb		
	bcf	status,rp0		; Return to bank0
	movlw	5               			; Load constanr to counter
	movwf	cnt8
loop	
	movlw	11111111b       		; RB5:RB3 = 111b
	movwf	portb	
	call	delay           			; Call assembly subroutine<delay>
     movlw   00000000b  		; RB5:RB3 = 000b
     movwf   portb
     call    delay           ; Call assembly subroutine<delay>
     decfsz  cnt8,1          ; Decreased file and skip if cnt8 = 0
     goto    loop            ; If cnt8 <> 0 then do again    
     return                  ; Return 
delay	                        ; Delay subroutine ~ 200 mS  
	clrf	dv1             			; Clear dv1 (dv1 = 00)
	clrf	dv2,1           			; Clear dv2 (dv2 = 00)
	movlw	5               			; dv3 = 5
	movwf	dv3
	decfsz dv1,1           		; Skip if dv1 = 0
	goto   $-1
	decfsz dv2,1            ; Skip if dv2 = 0
	goto   $-3
	decfsz dv3,1            ; Skip if dv3 = 0
	goto   $-5
	return                  ; Return
ENDASM
'*********************** END OF ASSEMBLY ****************	
