'*****************************************************************
'* File	: L0901.BAS                             								*
'* Description 	: COUNT command operation            	
'* Compiler : PICBASIC PRO Demo/V2.44 or higher				
'* Author :	Natthapol Wongsoonthornchai					
'* Copyright 2004 Innovative Experiment Co.,Ltd.     	
'*****************************************************************
@ DEVICE PIC16F877,HS_OSC,LVP_OFF,BOD_OFF,CPD_OFF,PROTECT_OFF,WDT_OFF
DEFINE	OSC	     	20		' 20 MHz. <HS mode>
DEFINE  	LCD_BITS 	4    		' Data bus 4 bit mode
DEFINE	LCD_LINES 	2      		' 2 Lines
DEFINE	LCD_DREG  	PORTD  		' Use portd as data port 
DEFINE	LCD_DBIT  	4	    	' Upper 4 bit of portd <D7:D4>
DEFINE	LCD_RSREG 	PORTC  		' RS pin = RC0 
DEFINE  	LCD_RSBIT 	0  
DEFINE	LCD_EREG   	PORTC  		' Enable pin = RC5 
DEFINE  	LCD_EBIT   	5 	
	
RESULT  VAR     WORD      		' Word size only

ADCON1 = 7                 				' Disable analog port (both port A and E)

PAUSE	 1000		    			' Delay >500 ms for LCD start-up
LCDOUT  $FE,1		    		' Clear display and return home
HPWM    1,(50*255)/100,2000  	' PWM frequency = 2kHz,Duty cycle = 50% 							 @RC2/CCP1 pin
LOOP1:
	COUNT   PORTA.0,1000,RESULT
	GOSUB   SHOW
	GOTO    LOOP1

SHOW:
	LCDOUT $FE,$80,"Freq=",dec5 RESULT ," Hz."
	RETURN
