'****************************************************************
'*   File	: L1101.BAS                                      *
'*  Description 	: DEBUG command operation -1                        *
'* Compiler : PICBASIC PRO Demo/V2.44 or higher
'* Author :	Natthapol Wongsoonthornchai
'* Copyright 2004 Innovative Experiment Co.,Ltd.     *
'****************************************************************
'****** DEFINED CHIPs CONFIGURATION ****************************************        
@   DEVICE  PIC16F877,HS_OSC,LVP_OFF,BOD_OFF,PWRT_OFF,WDT_OFF
        DEFINE  OSC         20      ' Xtal 20 MHz.

'****** DEFINED DEBUG PARAMETERS ********************************************
        DEFINE  DEBUG_REG   PORTC   ' RC6 is TX pin
        DEFINE  DEBUG_BIT   6            
        DEFINE  DEBUG_BAUD  9600    ' Baudrate = 9600 bps <8N1>
        DEFINE  DEBUG_MODE  0       ' Non-invert mode <drive through MAX232> 

'****** DEBUG/SERIAL CONSTANT ***********************************************
        Symbol CR   = 13            ' Carriage return : go to biginning of line
        SYMBOL LF   = 10            ' Line feed : new line       
        
'****************************************************************************
        X   VAR BYTE                ' Declared X as byte size
        X   =   33                  
'______________________________ MAIN PROGRAM _________________________________

debug   "*** SHOW ASCII ***" ,13,10                ' Show text and go to new line         
DEBUG   "ASCII CHARACTER IN X VARIABLE = " ,X,CR,LF' Show ASCII in X variable
DEBUG   REP "_" \ 76 ,CR,LF                        ' Send _ 76 times and go to next line
'_____________________________________________________________________________
DEBUG   "*** SHOW NUMBER WITH DIGIT AS DEFAULT ***" ,CR,LF
DEBUG   "BINARY      OF X = " , BIN X ,CR,LF       ' Show X <digit as default>
DEBUG   "DECIMAL     OF X = " , DEC X ,CR,LF       ' Show X <digit as default>
DEBUG   "HEXADECIMAL OF X = " , HEX X ,CR,LF,CR,LF ' Show X <digit as default>

DEBUG   "*** SHOW NUMBER WITH DIGIT AS DEFAULT AND INDICATED BASE OF NUMBER ***" ,CR,LF
DEBUG   "BINARY      OF X = " , IBIN X ,CR,LF      ' Show base of X <digit as default>
DEBUG   "DECIMAL     OF X = " , IDEC X ,CR,LF      ' Show base of X <digit as default>
DEBUG   "HEXADECIMAL OF X = " , IHEX X ,CR,LF,CR,LF' Show base of X <digit as default>

DEBUG   "*** SHOW NUMBER WITH DIGIT AS DEFAULT ,INDICATED BASE AND SIGN OF NUMBER ***" ,CR,LF
DEBUG   "BINARY      OF X = " , ISBIN X ,CR,LF      ' Show base and sign of x <digit as default>
DEBUG   "DECIMAL     OF X = " , ISDEC X ,CR,LF      ' Show base and sign of x <digit as default>
DEBUG   "HEXADECIMAL OF X = " , ISHEX X ,CR,LF,CR,LF' Show base and sign of x <digit as default>
        END                     ' End of program

