'****************************************************************
'* File	: L1201.BAS                                     
'* Description 	: DEBUGIN command operation                    
'* Compiler : PICBASIC PRO V2.44 or higher (not for demo)
'* Author :	Natthapol Wongsoonthornchai
'* Copyright 2004 Innovative Experiment Co.,Ltd.     
'****************************************************************
@ DEVICE  PIC16F877,HS_OSC,LVP_OFF,BOD_OFF,WDT_OFF 
DEFINE  OSC 20          					' XTAL 20MHz
DEFINE  DEBUGIN_REG	PORTC
DEFINE  DEBUGIN_BIT	7       		' RC7 = receive pin                
DEFINE 	DEBUGIN_MOD	0      		' Non-invert
        
DEFINE  DEBUG_REG 		PORTC
DEFINE  DEBUG_BIT   		6       		' RC6 = transmitter pin
DEFINE 	DEBUG_MODE 	0      	' Non-invert mode
        
DEFINE  DEBUG_BAUD	9600    	' Baudrate

LED1    VAR		PORTB.5
LED2    VAR		PORTB.4
LED3    VAR		PORTB.3 
I       VAR		BYTE
        
LOW LED1 :	LOW LED2 :	LOW  LED3 		' LED off

DEBUG   "Press 1 for LED1 ON/OFF",13,10 	' Show command
DEBUG   "Press 2 for LED2 ON/OFF",13,10
DEBUG   "Press 3 for LED3 ON/OFF",13,10
DEBUG  		"Press - for LED  OFF",13,10
DEBUG   "Press + for LED  ON",13,10          
DEBUG   "Ready...",13,10,13,10     

LOOP1:	DEBUGIN [I]             					' Received command        
		IF i = "-"  THEN LOFF
     		IF i = "+"  THEN LON
		IF I = "1"  THEN L1     			' Check command
		IF I = "2"  THEN L2       
		IF I = "3"  THEN L3    
		GOTO    LOOP1            					' If unknown command then loop

LOFF:   LOW    LED1             					' Turn off all LED
        LOW    LED2 
        LOW    LED3 
        GOTO   LOOP1
LON:    HIGH   LED1             					' Turn on all LED
        HIGH   LED2 
        HIGH   LED3 
        GOTO   LOOP1
L1:     TOGGLE LED1 
        GOTO    LOOP1        
L2:     TOGGLE  LED2 
        GOTO    LOOP1
L3:     TOGGLE  LED3
        GOTO    LOOP1
