'****************************************************************
'* File	: L2302.BAS                                      
'* Description 	: I2CREAD command operation                    
'* Compiler : PICBASIC PRO demo/V2.44 or higher 
'* Author :	Natthapol Wongsoonthornchai
'* Copyright 2004 Innovative Experiment Co.,Ltd.     
'****************************************************************
@ DEVICE PIC16F877,HS_OSC,LVP_OFF,BOD_OFF,WDT_OFF
DEFINE	OSC	 20		    ' Oscillator = HS mode     
DEFINE  I2C_SLOW   1 	' Standard 100kHz
'****** DEFINE LCD REGISTERS AND BITS ***************************
DEFINE  LCD_BITS   4    	' Data bus 4 bit mode
DEFINE	LCD_LINES  2      	' 2 Lines
DEFINE	LCD_DREG   PORTD  	' Use portd as data port 
DEFINE	LCD_DBIT   4	    ' Upper 4 bit of portd <D7:D4>
DEFINE	LCD_RSREG  PORTC 	' RS pin = RC0 
DEFINE  	LCD_RSBIT  0  
DEFINE	LCD_EREG   PORTC  	' Enable pin = RC5 
DEFINE  	LCD_EBIT   5 	

WORD_ADDR  CON  $00        	' Word address 
CONTROL    CON  %10100000  	' Page 0 of 2416       
SCL 	   VAR	PORTC.3    	' RC3 = clock line
SDA  VAR   PORTC.4    		' RC4 = data  line        
K    VAR   BYTE[16]   		' Array 16 bytes
J    VAR   BYTE
I    VAR   BYTE

'******************* MAIN PROGRAM ***********************
PAUSE   1000           		' Delay for LCD start-up
LCDOUT  $FE,1           	' Clear LCD        
I2CREAD SDA,SCL,CONTROL,WORD_ADDR,[STR K\16]  	' Sequential read
LCDOUT  STR K\16

STOP                    	' End of job
