'****************************************************************
'* File	: L2801.BAS                                     
'* Description 	: LOOKDOWN command operation                   
'* Compiler : PICBASIC PRO demo/V2.44 or higher 
'****************************************************************
@ DEVICE PIC16F877,HS_OSC,LVP_OFF,WDT_OFF,BOD_OFF
DEFINE	OSC	  20	    	' 20 MHz. <HS mode>
'****** DEFINE LCD REGISTERS AND BITS ***************************
DEFINE  LCD_BITS 	4      	' Data bus 4 bit mode
DEFINE	LCD_LINES 	2      	' 2 Lines
DEFINE	LCD_DREG  	PORTD  	' Use portd as data port 
DEFINE	LCD_DBIT   	4	    ' Upper 4 bit of portd <D7:D4>
DEFINE	LCD_RSREG 	PORTC  	' RS pin = RC0 
DEFINE  LCD_RSBIT  	0  
DEFINE	LCD_EREG   	PORTC  	' Enable pin = RC5 
DEFINE  LCD_EBIT    5 	
'****** DEFINE DEBUGIN REGISTERS AND BITS ***********************
DEFINE  DEBUGIN_REG PORTC    
DEFINE  DEBUGIN_BIT 7       ' RC7 = Receive pin
DEFINE 	DEBUGIN_MOD	0      	' Non-invert mode
DEFINE  DEBUG_BAUD  9600    ' Baudrate = 9600 bps 
SEARCH 	VAR BYTE    		' Byte size only
J      	VAR BYTE  
PAUSE   1000            	' Delay for LCD start-up
LCDOUT  $FE,1            	' Clear LCD
LCDOUT  "LOOKDOWN"      	' Show text
PAUSE   500
LOOP1:	DEBUGIN [SEARCH]    ' Wait for data <ASCII>
    		LOOKDOWN  SEARCH,["PIC16F87X"],J    	' Put data in J variable
    		LCDOUT  $FE,1,#J        				' Show address of list
    		GOTO    LOOP1
