'****************************************************************
'* File	: L3001.BAS                                      
'* Description 	: LOOKUP command operation                    
'* Compiler : PICBASIC PRO demo/V2.44 or higher 
'* Author :	Natthapol Wongsoonthornchai
'* Copyright 2004 Innovative Experiment Co.,Ltd.     
'****************************************************************
@ DEVICE PIC16F877,HS_OSC,LVP_OFF,WDT_OFF,BOD_OFF
DEFINE		OSC	20	    ' 20 MHz. <HS mode>
'****** DEFINE LCD REGISTERS AND BITS ***************************
DEFINE 	LCD_BITS   		4      ' Data bus 4 bit mode
DEFINE	LCD_LINES   	2      ' 2 Lines
DEFINE	LCD_DREG   		PORTD  ' Use portd as data port 
DEFINE	LCD_DBIT   		4	   ' Upper 4 bit of portd <D7:D4>
DEFINE	LCD_RSREG    	PORTC  ' RS pin = RC0 
DEFINE  	LCD_RSBIT    	0  
DEFINE	LCD_EREG    		PORTC  ' Enable pin = RC5 
DEFINE  	LCD_EBIT   		5 	
'****** DEFINE DEBUGIN REGISTERS AND BITS ***********************
DEFINE  	DEBUGIN_REG  	 PORTC    
DEFINE  	DEBUGIN_BIT 	7       		' RC7 = RCV PIN
DEFINE 	DEBUGIN_MODE 0      		' Non-invert mode
DEFINE  	DEBUG_BAUD  	9600    	' Baudrate = 9600 bps
'****************************************************************    
INDEX		VAR  	BYTE
J    		VAR  	BYTE 	' Byte size only
    
PAUSE   1000            					' Delay for LCD start-up
LCDOUT  $FE,1            					' Clear LCD
LCDOUT  "Ready"
PAUSE   500

LOOP:		DEBUGIN [DEC1 INDEX] 			' Wait for pointer
    		LOOKUP  INDEX,["9876543210"],J  ' Put data to J
    		LCDOUT  $FE,1, J
    		GOTO    LOOP
