'****************************************************************
'* File	: L3101.BAS                                      
'* Description 	: LOOKUP2 command operation                    
'* Compiler : PICBASIC PRO demo/V2.44 or higher 
'* Author :	Natthapol Wongsoonthornchai
'* Copyright 2004 Innovative Experiment Co.,Ltd.     
'****************************************************************
@ DEVICE PIC16F877,HS_OSC,LVP_OFF,WDT_OFF,BOD_OFF
DEFINE	OSC	20	    			' 20 MHz. <HS mode>
'****** DEFINE LCD REGISTERS AND BITS ***************************
DEFINE	LCD_BITS     4      	' Data bus 4 bit mode
DEFINE	LCD_LINES    2      	' 2 Lines
DEFINE	LCD_DREG     PORTD  	' Use portd as data port 
DEFINE	LCD_DBIT     4	    	' Upper 4 bit of portd <D7:D4>
DEFINE	LCD_RSREG    PORTC  	' RS pin = RC0 
DEFINE  LCD_RSBIT    0  
DEFINE	LCD_EREG     PORTC  	' Enable pin = RC5 
DEFINE  LCD_EBIT     5 	
'****** DEFINE DEBUGIN REGISTERS AND BITS ***********************
DEFINE  DEBUGIN_REG	PORTC    
DEFINE  DEBUGIN_BIT 7           ' RC7 = Receive pin
DEFINE 	DEBUGIN_MODE  0         ' Non-invert mode
DEFINE  DEBUG_BAUD  9600        ' Baudrate = 9600 bps  
'****************************************************************    
INDEX   VAR     BYTE
JJ      VAR     WORD    
    
PAUSE   1000            		' Delay for LCD start-up
LCDOUT  $FE,1            		' Clear LCD
LCDOUT  "Ready"
PAUSE   500

LOOP1 : 
		DEBUGIN [DEC1 INDEX]     ' Wait for pointer
    	LOOKUP2 INDEX,[1000,1500,2000,2500,3000,3500,4000,4500,5000,5500],JJ ' Put data to JJ
    	LCDOUT  $FE,1, #JJ       ' Show value in JJ on LCD
    	GOTO    LOOP1
