'****************************************************************
'* File	: L3401.BAS                                      
'* Description 	: Interface DS1820 Temperature sensor with OWIN/OWOUT command  
'* Compiler : PICBASIC PRO demo/V2.44 or higher 
'* Author :	Natthapol Wongsoonthornchai
'* Copyright 2004 Innovative Experiment Co.,Ltd.     
'****************************************************************
@ DEVICE PIC16F877,HS_OSC,LVP_OFF,WDT_OFF,BOD_OFF
DEFINE	OSC	20	    		    ' 20 MHz. <HS mode>
DQ      VAR	PORTB.1	    	    ' One-wire data pin
TEMP 	VAR	WORD	    		' Temperature storage
COUNT_REMAIN 	VAR    BYTE	    ' Count remaining
COUNT_PER_C 	VAR	   BYTE	    ' Count per degree C

' Define LCD registers and bits       
DEFINE 	LCD_BITS     4      	' Data bus 4 bit mode
DEFINE	LCD_LINES    2      	' 2 Lines
DEFINE	LCD_DREG     PORTD  	' Use portd as data port 
DEFINE	LCD_DBIT     4	    	' Upper 4 bit of portd <D7:D4>
DEFINE	LCD_RSREG    PORTC  	' RS pin = RC0 
DEFINE  LCD_RSBIT    0  
DEFINE	LCD_EREG     PORTC  	' Enable pin = RC5 
DEFINE  LCD_EBIT     5 	
'************ DEFINE 1-WIRE MODE ((LOW SPEED MODE(~16kBIT))***********        
MODE0   CON     0       ' Byte size, No RESET
MODE1   CON     1       ' Byte size, Pre RESET
MODE4   CON     4       ' Bit size, No RESET

'*************  MAIN  PROGRAM **************************************
PAUSE   1000                ' Delay 1 second for LCD start-up        
LCDOUT  $FE,$40+(8*0),$18,$18,$00,$07,$08,$08,$08,$07 ' Write char in CGRAM address 0        
LCDOUT  $FE,$40+(8*1),$18,$18,$00,$0F,$08,$0E,$08,$08 ' Write char in CGRAM address 1
MAINLOOP: 	OWOUT DQ,MODE1, [$CC, $44]       ' Start temperature conversion
WAITLOOP: 	OWIN DQ,MODE4, [COUNT_REMAIN]	 ' Check for still busy converting
   			If COUNT_REMAIN = 0 THEN WAITLOOP
   			OWOUT DQ,MODE1, [$CC, $BE]	   ' Read the temperature
  			OWIN DQ,MODE0, [Temp.LOWBYTE, Temp.HIGHBYTE, SKIP 4,COUNT_REMAIN, COUNT_PER_C]

' Calculate temperature in degrees C to 2 decimal places not valid for negative temperature)
  			TEMP = (((TEMP >> 1)*100)-25)+((( COUNT_PER_C-COUNT_REMAIN)*100)/ COUNT_PER_C)
   			LCDOUT $FE,1,"t= ",DEC (TEMP/100),".",DEC2 TEMP," ",0

' Calculate temperature in degrees F to 2 decimal places (not valid for negative temperature)
   			TEMP = (TEMP */ 461) + 3200
   			LCDOUT $FE,$C0,"t= ",DEC (TEMP/100),".",DEC2 TEMP," ",1
   			PAUSE 1000                     					' Display about once a second
   			GOTO MAINLOOP				                    ' Do it forever
