'****************************************************************
'* File	: L3402.BAS                                      
'* Description 	: Interface DS1990A iButton serial number with OWIN/OWOUT command  
'* Compiler : PICBASIC PRO demo/V2.44 or higher 
'* Author :	Natthapol Wongsoonthornchai
'* Copyright 2004 Innovative Experiment Co.,Ltd.     *
'****************************************************************
@ DEVICE PIC16F877,HS_OSC,LVP_OFF,WDT_OFF,BOD_OFF
DEFINE	OSC	     20	    ' 20 MHz. <HS mode>
'****** DEFINE LCD REGISTERS AND BITS ***************************
DEFINE LCD_BITS     4      ' Data bus 4 bit mode
DEFINE	LCD_LINES    2      ' 2 Lines
DEFINE	LCD_DREG     PORTD  ' Use portd as data port 
DEFINE	LCD_DBIT     4	    ' Upper 4 bit of portd <D7:D4>
DEFINE	LCD_RSREG    PORTC  ' RS pin = RC0 
DEFINE  	LCD_RSBIT    0  
DEFINE	LCD_EREG     PORTC  ' Enable pin = RC5 
DEFINE  	LCD_EBIT     5 	
'************ Define 1-WIRE mode ((Low spees mode(~16kBIT))***********        
MODE0   CON     0       ' Byte size, No RESET
MODE1   CON     1       ' Byte size, Pre RESET
'*********************************************************************
DQ	VAR		PORTB.1	       		' Data pin = RB1
SPK  	VAR     		PORTA.4         			' RA4 = sound out
Z	VAR		BIT
I 	VAR 		BYTE         
J   	VAR   BYTE         
K	VAR		BYTE
CRC	VAR		BYTE
DAT	VAR		BYTE[8]	

'+++++++++++++++++++ MAIN PROGRAM ++++++++++++++++++++++         
PAUSE   1000           					' Delay for LCD start-up
LCDOUT  $FE,$01         				' Clear display
LCDOUT  "Ready..."
            
LOOP1:	OWOUT 	DQ,MODE1,[$33]	     	' Send read command
		OWIN 	DQ,MODE0,[STR DAT\8] ' Read data and store in DAT 
		GOSUB	CRC_CHECK             
        		K = DAT[0]
		FOR I = 0 TO 6     		' 7 loops  
        			K = K | DAT[I]         		' Inclusive OR
		NEXT I
		IF (CRC=$00) AND (K=$00) THEN LOOP1     	' Wrong CRC
		IF (CRC=$14) AND (K=$FF) THEN LOOP1     	' Wrong CRC
		IF CRC <> DAT[7] THEN LOOP1            			' Wrong CRC
        SEROUT2 PORTC.6, 84, ["CODE :",HEX2 DAT[0],13,10]
         
        		LCDOUT  $FE,$80      			' Point to upper line 
        		LCDOUT  "CODE:",HEX2 DAT[0],"  CRC:",HEX2 DAT[7] 
										' Show family code AND CRC VALUE
        		LCDOUT  $FE,$C0,"ID:"   		' Point to lower line and show ID
      		FOR  J = 6 TO 1 STEP -1        
        			LCDOUT  HEX2 DAT[J]       		' Show ID of DS1990A
        		NEXT J        
        		FREQOUT SPK,40,2100
        		STOP                    							' End of job

CRC_CHECK: CRC	 =  00	        			' CRC = 00 before calculation
        			FOR  J = 0 TO 6			' 7 loops
				K = DAT[J]
				FOR I = 0 TO 7			' Shift 8 times
					Z = CRC.0 ^ K.0  		' XOR bitwise
					CRC.3 = CRC.3 ^ Z
					CRC.4 = CRC.4 ^ Z
					CRC	 = CRC  >> 1 		' Shift right 
					K = K >> 1
					CRC.7 = Z	
				NEXT I	
			NEXT J 
			RETURN
