'****************************************************************
'*  Filename    : L4601.BAS                                      
'*  Description 	: SELECT CASE command operation
'****************************************************************
@ DEVICE PIC16F877,HS_OSC,LVP_OFF,BOD_OFF,WDT_ON
DEFINE  OSC  	20      		' HS MODE
DEFINE  DEBUG_REG	PORTC
DEFINE  DEBUG_BIT	6      		' RC6 = XMIT
DEFINE  DEBUG_BAUD	9600  	    ' 9600 bps
DEFINE  DEBUG_MODE	0     		' Non-invert

B10 	VAR 		BYTE		' Used to count and specify the case
B10 = 0
LOOP1:							' First example
		PAUSE 250
		B10 = B10 + 1			' Increment B10

		SELECT CASE B10		    ' Begin Select CASE - use B10
			CASE 1				' Execute if B10=1
				DEBUG LOOP1 CASE 1,13,10		' Send string and new line
				
			CASE 2				' Execute if B10=2
				DEBUG LOOP1 CASE 2,13,10

			CASE 4				' Execute if B10=4
				DEBUG LOOP1 CASE 4,13,10

			CASE Is >5			' Execute if B10 > 5
				CLEAR				' Set B10 to 0
				DEBUG 13,10		' Send new line
				GOTO LOOP2		' Finished - jump to second example

			CASE Is >2			' Execute if B10>2 (but not >5 or =4)
				DEBUG LOOP1 CASE 3,5,13,10

		END SELECT				' Resume here after CASE is executed

		GOTO LOOP1				' Continue first example

LOOP2:	PAUSE 250				' Second Example
		B10 = B10 + 1			' Increment B10
		SELECT CASE B10		    ' Begin Select CASE - use B10

			CASE 1				' Execute if B10=1
				DEBUG LOOP2 CASE 1,13,10

			CASE 2				' Execute if B10=2
				DEBUG "LOOP2 CASE 2",13,10

			CASE 4				' Execute if B10=4
				DEBUG "LOOP2 CASE 4",13,10

			CASE IS <6		' Execute if B10<6 (but not = 1,2, or 4)
				DEBUG "LOOP2 CASE 3,5",13,10

			CASE ELSE			' Execute if no other conditions met (B10>5)
				CLEAR			' Set B10 to 0
				DEBUG 13,10	' Send new line
				GOTO LOOP1	' Finished - jump back to first example

		END SELECT			' Resume here after CASE is executed
			
		GOTO LOOP2			' Continue second example
