'****************************************************************
'*  File	: L5301.BAS                                      
'*  Description 	: SHIFTIN-SHIFTOUT command operation                       
'*  Author  : Natthapol Wongsoonthornchai                                                   
'****************************************************************
@ DEVICE PIC16F877,HS_OSC,LVP_OFF,BOD_OFF,WDT_OFF
DEFINE	OSC	20	    			' 20 MHz. <HS mode only>       
DAT595 	VAR  	PORTB.0    		' RB0 = DATA pin
CLK595	VAR  	PORTC.1    		' RC1 = CLOCK pin    
LAT595 	VAR  	PORTC.2    		' RC2 = LATCH pin 
DAT165  VAR  	PORTE.0   		' RE0 = DATA pin
CLK165  VAR 	PORTE.1   		' RE1 = CLOCK piN       
LOAD   	VAR  	PORTE.2    		' RE2 = LOAD pin    
I		VAR 	BYTE

ADCON1 = 2       				' RE2:RE0 as digital port
LOOP:   GOSUB   READ_DATA
        GOSUB   SEND_DATA
        GOTO    LOOP  
SEND_DATA:	LOW   LAT595                 
       		SHIFTOUT DAT595,CLK595,5,[I]	' MSB first ,Clock idel high - active low
        	HIGH   LAT595               	' Send pulse to LATCH pin
        	LOW    LAT595
        	RETURN                  
READ_DATA:  LOW    LOAD            			' Load parallel input
        	HIGH   LOAD            
        	SHIFTIN DAT165,CLK165,1,[I]     ' Read data into I variable
        	I = ~I       					' Invert I       
        	RETURN
